HEX

\ Configure the ZON-X81 sound device
\ Write data D in register R of PSG, n is the number of
\ registers that will be written
CODE WRITEAY  ( Dn Rn ... D2 R2 D1 R1 n -- )
  69 C,          \ ld l,c
  C1 C,          \ pop bc
  79 C,          \ ld a,c    <---+
  D3 C, DF C,    \ out ($df),a   |
  C1 C,          \ pop bc        |
  79 C,          \ ld a,c        |
  D3 C, 0F C,    \ out ($0f),a   |
  C1 C,          \ pop bc        |
  2D C,          \ dec L         |
  20 C, F5 C,    \ jr nz,-9  ----+
  NEXT           \ jp NEXT

\ Read keyboard and ZXPand joystick
CODE JOYREAD ( -- c )
  C5 C,         \ push bc       ; save old TOS
  01 C, E007 ,  \ ld bc,$e007   ; read the previously latched joystick value
  ED C, 78 C,   \ in a,(c)      ; ZXPAND:  UDLRF???
  E6 C, F8 C,   \ and $f8       ; bottom 3 bits are undefined
  0F C,         \ rrca          ;
  0F C,         \ rrca          ;
  0F C,         \ rrca          ;
  C5 C,         \ push bc       ; save ZXPand port address
  6F C,         \ ld l,a        ; save joystick value (000UDLRF)
  01 C,	FE ,    \ ld bc,$00fe   ; read keyboard (all sectors)
  ED C, 78 C,   \ in a,(c)      ; (???UDLRF)
  A5 C,         \ and l         ; combine with ZXPand joystick
  C1 C,         \ pop bc        ; restore ZXPand port address
  F5 C,         \ push af       ; save keyboard + Joystick value
  3E C, A0 C,   \ ld a,$a0      ; start the joystick value latching process for next time
  ED C, 79 C,   \ out (c),a     ;
  F1 C,         \ pop af        ; restore keyboard + Joystick value at TOS
  4F C,         \ ld c,a        ;
  06 C, 00 C,   \ ld b,0        ;
  NEXT          \ jp NEXT	

\ Invert screen
CODE INVERTE ( -- )
 21 C, 40B7 ,    \  ld hl,16567
 06 C, 20 C,     \  ld b,32
 7E C,           \  ld a,(hl)
 EE C, 80 C,     \  xor $80
 77 C,           \  ld (hl),a
 23 C,           \  inc hl
 10 C, F9 C,     \  djnz -7
 NEXT            \  jp NEXT


DECIMAL

: WHISTLE  ( i f1 f2 -- )
  DO I 0 1 WRITEAY DUP 
  +LOOP
  DROP 0 0 1 WRITEAY
;

: AT  ( y x -- )
  SWAP 256 * + 26624 +
  16475 !
;

: SPACES  ( n -- )  
  ?DUP IF 0 DO SPACE LOOP THEN ;

: 0> 0 > ;

: MOD /MOD DROP ;

0 VARIABLE X   0 VARIABLE H   0 VARIABLE V
0 VARIABLE U   0 VARIABLE L   0 VARIABLE N
0 VARIABLE R   0 VARIABLE P   0 VARIABLE S
0 VARIABLE D   0 VARIABLE T

CREATE INVTAB 50 ALLOT

: CLRSCR
  2 0 AT 608 SPACES 
;

: PAUSA
  0
  DO
   200 0
   DO
   LOOP
  LOOP 
;

: USING
  AT DUP DUP DUP 1000 <
  IF 48 EMIT
  THEN
  100 <
  IF 48 EMIT
  THEN
  10 <
  IF 48 EMIT
  THEN
  . 
;

: RND
  16436 C@ 31 AND 
;

: GR
  8 * 16384 + DUP 7 +
  DO I C! -1 +LOOP
;

    1   3   7  13  15   5   8   4  ASCII a GR
  128 192 224 176 240 160  16  32  ASCII b GR
    1   3   7  13  15   2   5  10  ASCII c GR
  128 192 224 176 240  64 160  80  ASCII d GR
    8  36  47  59  63  31   8  16  ASCII e GR
   32  72 232 184 248 240  32  16  ASCII f GR
    8   4  15  27  63  63  40   6  ASCII g GR
   32  64 224 176 248 248  40 192  ASCII h GR
    3  31  63  57  63  14  25  12  ASCII i GR
  192 248 252 156 252 112 152  48  ASCII j GR
    3  31  63  57  63   6  13  48  ASCII k GR
  192 248 252 156 252  96 176  12  ASCII l GR
    1   3   3 127 255 255 255 255  ASCII m GR
    0 128 128 252 254 254 254 254  ASCII n GR
    0   7  31  63 109 255  57  16  ASCII o GR
    0 224 248 252 182 255 156   8  ASCII p GR
    4  34  16   8  96   4  18  36  ASCII q GR
   64 136  16  32  12  32 144  72  ASCII r GR
    0   1   1   1   1   1   0   0  ASCII s GR
   66  32  71  15  30  76 135  35  ASCII t GR
    2 100 240 250 217 240 196  18  ASCII u GR
  251 251 251   0 223 223 223   0  ASCII v GR
    0   0   0   0   0   0 255   0  ASCII w GR
    3  28  35  32  33  35  33  32  ASCII x GR
  224  28 226   2 194 226 194 130  ASCII y GR
   37  47  46  38  32  28   3   0  ASCII z GR
   82 122  58  50   2  28 224   0  ASCII { GR

FORGET GR

: INSTRU
  CLS
  160 57351 PC!
  1 8 AT ." NUCLEAR INVADERS"
  6 4 AT ." CONTROLS: LEFT  = K"
  7 14 AT ." RIGHT = L"
  8 14 AT ." FIRE  = ENTER"
  14 6 AT ." *PRESS KEY TO START*"
  20 6 AT 127 EMIT ."  SCAINET SOFT, 2013"
  21 3 AT ." ZX81 VERSION BY TODDY SOFT"
  BEGIN
   JOYREAD 31 <
  UNTIL
  9 PAUSA 
;

: PRESENTA
  CLS
  ."  SCORE<1>   HI-SCORE   SCORE<2>"
  S @ 1 3 USING
  R @ 1 14 USING
  5 14 AT ." PLAY"
  7 8 AT ." NUCLEAR INVADERS"
  10 5 AT ." *SCORE ADVANCE TABLE*"
  12 9 AT ." op =? MYSTERY"
  14 9 AT ." cd =30 POINTS"
  16 9 AT ." gh =20 POINTS"
  18 9 AT ." kl =10 POINTS"
  22 4 AT ." mnmn"
  13 SPACES ." CREDIT 00"
  BEGIN
   JOYREAD 31 <
  UNTIL
  CLRSCR 21 1 AT ." wwwwwwwwwwwwwwwwwwwwwwwwwwwwww"
  22 2 AT ." 3"
  11 9 AT ." PLAY PLAYER<1>"
  10 0
  DO
   1 3 AT 4 SPACES
   3 PAUSA 1 3 AT
   ." 0000"
   3 PAUSA
  LOOP
  3 L ! 2 N ! 0 S ! 0 T !
;

: INICIO
  CLRSCR 15 15 N @
  - DUP U ! AT
  N @ 2 * 2 + DUP 0
  DO ." v" LOOP
  4 U @ AT 0
  DO ." v" LOOP
  4 13
  DO
   U @ DUP I SWAP AT  ." v"
   N @ 0
   DO ." xy" LOOP
   ." v" I 1+ SWAP AT ." v"
   N @ 0
    DO ." z{" LOOP
   ." v" -2
  +LOOP
  99 103 DUP 107 DUP
  4 13
  DO
   I 1 AT DUP EMIT
   DUP 1+ EMIT I 29 AT
   DUP EMIT 1+ EMIT -2
  +LOOP
  3 0 5 0 99
  3 0 7 0 103
  3 0 9 0 103
  3 0 11 0 107
  3 0 13 0 107
  3 0 5 29 99
  3 0 7 29 103
  3 0 9 29 103
  3 0 11 29 107
  3 0 13 29 107
  INVTAB DUP 49 +
  DO
   I C! -1
  +LOOP
  -200 U ! 3 X ! 0 V !
  INVTAB P ! 30 D !
  0 0 0 1 80 4 0 5 10 13
  0 11 1 12 0 10 15 8 58 7
  10 WRITEAY
;

: MOVER
  X @ DUP 27 <
  IF JOYREAD 2 AND 0=
     IF X @ 1+ X !
     THEN
  THEN
  3 >
  IF JOYREAD 4 AND 0=
     IF X @ 1- X !
     THEN
  THEN
  20 X @ 1- AT ."  mn " 
;

: INVASOR
  P @ C@ 0>
  IF P @ 1+ C@ 0=
   IF RND D @ 5 <
    IF 10
    ELSE 26
    THEN
    >
    IF 1 P @ 1+ C!
    THEN
    0
   ELSE
    P @ [ INVTAB 25 + ] LITERAL <
    IF 1
    ELSE -1
    THEN
    DUP DUP
    P @ 3 + C@ +  P @ 3 + C!
    P @ 2 + C@    P @ 3 + C@  AT
    0>
    IF SPACE
    THEN
    P @ 4 + C@   P @ 3 + C@
    2 MOD 0>
    IF 2 -
    THEN
    DUP EMIT 1+ EMIT
    0<
    IF SPACE
    THEN
    P @ 3 + C@  DUP 14 N @ -
    =
    IF
     0 10 1 WRITEAY
     DROP 1
    ELSE
     15 N @ +
     =
     IF 0 10 1 WRITEAY  1
     ELSE 0
     THEN
    THEN
   THEN
  ELSE 0
  THEN
  P @ [ INVTAB 45 + ] LITERAL =
  IF INVTAB
  ELSE P @ 5 +
  THEN
  P ! 
;

: UFO
  U @ DUP 0<
  IF
   1+ U !
  ELSE
   DUP 270 >
   IF
    10 / 3 SWAP AT 3 SPACES -200 U !
    0 10 1 WRITEAY
   ELSE
    DUP 0=
    IF 16 10 1 WRITEAY
    THEN
    5 + DUP U ! 10 / 3 SWAP AT ."  op"
   THEN
  THEN 
;

: IMPACTO
  26624 V @ 256 * 64 + +
  H @ + C@ 
  0 =
  IF 0
  ELSE
   V @ 15 <
   IF V @ 3 =
    IF
     3 U @ 10 / 1+ AT ." tu"
     0 10 1 WRITEAY
     1 130 0 WHISTLE
     -2 0 130 WHISTLE
     RND 12 / 1+ 50 * DUP
     3 U @ 10 / 1+ AT .
     DUP T +! S @ + DUP S !
     1 3 USING
     20 PAUSA
     3 U @ 10 / AT 4 SPACES
     -200 U !
    ELSE
     D @ 1- D !
     V @ 3 - 2/
     H @ 15 >
     IF 5 + THEN
     V @ DUP 5 =
     IF DROP 30
     ELSE
      10 >
      IF 10
      ELSE 20
      THEN
     THEN
     DUP T +! S @ + DUP S !
     1 3 USING
     1- 5 * INVTAB + V !
     V @ 2 + C@
     V @ 3 + C@
     DUP 15 <
     IF 1+
     THEN
     OVER OVER AT ." qr"
     1 180 80 WHISTLE AT
     2 SPACES V @ DUP C@
     1- SWAP C!
     V @ C@ 0>
     IF 
      0 V @ 1+ C!
      H @ 15 <
      IF 0
      ELSE 29
      THEN
      V @ 3 + C!
      V @ 2 + C@  V @ 3 + C@  AT
      H @ 15 <
      IF SPACE
      THEN
      V @ 4 + C@ DUP
      EMIT 1+ EMIT
     THEN
    THEN
   THEN
   0 V ! 1
  THEN 
;

: DISPARO
  V @ 0=
  IF JOYREAD 1 AND 0=
   IF 
    X @ H ! 19 V !
    50 7 1 WRITEAY 31 0
    DO I 6 1 WRITEAY
    LOOP
    58 7 1 WRITEAY
   THEN
  ELSE
   V @ DUP H @ AT
   16475 @ 64 + C@ 1 =
   IF SPACE
   THEN
   5 <
   IF 0 V !
   ELSE
    V @ 2- V !
    IMPACTO 0=
    IF V @ H @ AT
     115 EMIT
    THEN
   THEN
  THEN 
;

: VIDAS
  10 0
  DO
    INVERTE
    1 180 0 WHISTLE
   -1 0 180 WHISTLE
  LOOP
  30 PAUSA L @ 1-
  DUP DUP 0> 
  IF
   DUP 22 2 AT .
   DUP 2 * 2 +
   22 SWAP AT
   2 SPACES
  ELSE
   17 11 AT ." GAME  OVER"
   S @ R @ >
   IF S @ R !
   THEN
  THEN
  L ! 0= 
;

: FASE
  D @ 0=
  IF
   U @ 0<
   IF
    N @ DUP 5 <
    IF 1+ 
    THEN
    N ! 100 PAUSA INICIO
    2 1000 0 WHISTLE
   THEN
  THEN 
;

: BONUS
  1000 T @ <
  IF
   T @ 1000 - T !
   N @ 4 >
   L @ 6 <  AND
   IF
    -3 0 600 WHISTLE
    L @ DUP 1+ DUP L ! 22 2 AT .
    2 * 2+ 22 SWAP AT ." mn"
   THEN
  THEN
;

: RUN
  9 PAUSA INVERTE INSTRU
  BEGIN
   PRESENTA
   BEGIN
    INICIO
    BEGIN
     2 PAUSA
     MOVER DISPARO UFO
     BONUS FASE INVASOR
    UNTIL
    VIDAS
   UNTIL
   200 PAUSA 0
  UNTIL 
;
